! *******************************************************************
! * INCLUDE-FILE : DATUM.INC                                        *
! *-----------------------------------------------------------------*
! * ENTHALTENE PROZEDUREN : SCHALTJAHR                              *
! *                         TAGESNUMMER                             *
! *                         WOCHENTAG                               *
! *-----------------------------------------------------------------*
! * ERKLAERUNG : DIESE PROZEDUREN WERDEN FUER DIE WOCHENTAGS-       *
! *              BERECHNUNG BENTIGT (MONTAG,DIENTSTAG,...).        *
! *              MAN KANN ABER NOCH VIEL MEHR MIT IHNEN BERECHEN !  *
! *              SIEHE DAZU C'T,1997,HEFT 15,SEITE 312,             *
! *              'IMMER WIEDER SONNTAG, ALGORITHMEN ZUR DATUMS-     *
! *              BERECHNUNG')                                       *
! *-----------------------------------------------------------------*
! * AUTOR            : LARS SCHREINER                               *
! *-----------------------------------------------------------------*
! * ERSTELLT         : 15.05.1998                                   *
! * LETZTE AENDERUNG : 15.05.1998                                   *
! *******************************************************************

! *******************************************************************
! *    SCHALTJAHR BERECHNET OB DAS ANGEGEBENE JAHR EINSCHALTJAHR    *
! *    IST ODER NICHT ! (C'T,1997,HEFT 15,SEITE 312,'IMMER WIEDER   *
! *                     SONNTAG, ALGORITHMEN ZUR DATUMSBERECHNUNG') *
! *******************************************************************

SCHALTJAHR:PROC(JAHR FIXED(15)) RETURNS(FIXED(15));

   IF ( ((JAHR REM 4) EQ 0) AND ((JAHR REM 100) NE 0) ) 
      OR ((JAHR REM 400) EQ 0) THEN
      RETURN(1);
   ELSE
      RETURN(0);
   FIN;
END; /* SCHALTJAHR */


! *******************************************************************
! *         TAGESNUMMER ORDNET JEDEM TAG EINE NUMMER ZU !           *
! * (C'T,1997,HEFT 15,SEITE 312,'IMMER WIEDER SONNTAG, ALGORITHMEN  *
! *                     ZUR DATUMSBERECHNUNG')                      *
! *******************************************************************

TAGESNUMMER:PROC( (JAHR,MONAT,TAG) FIXED(15) ) RETURNS(FIXED(15));

DCL (D,E)      FIXED(15)   INIT(0,0);   
   
   D = ENTIER((MONAT+10)/13);
   E = ENTIER(TAG+(611*(MONAT+2))/20 - 2*D - 91);
  
   RETURN(E+SCHALTJAHR(JAHR)*D);
END; /* TAGESNUMMER:PROC */

! *******************************************************************
! *    WOCHENTAG ORDNET JEDER TAGESNUMMER EINE NAMENSNUMMER ZU !    *
! *        Z.B.: SONNTAG = 0, MONTAG = 1,...,SAMSTAG = 6 !          *
! * (C'T,1997,HEFT 15,SEITE 312,'IMMER WIEDER SONNTAG, ALGORITHMEN  *
! *                     ZUR DATUMSBERECHNUNG')                      *
! *******************************************************************

WOCHENTAG:PROC( (JAHR,TAGNUMMER) FIXED(15)) RETURNS(FIXED(15));

DCL (J,C)     FIXED(15)  INIT(0,0);
   
   J =  (JAHR-1) REM 100 ;
   C = ENTIER( (JAHR-1) / 100 );
   RETURN( (28+J+TAGNUMMER+ENTIER(J/4)+ENTIER(C/4)+5*C) REM 7 );
END; /* WOCHENTAG:PROC */

! *******************************************************************
! *           TAGNAME ORDNET JEDEM TAG EINEN NAMEN ZU !             *
! *******************************************************************

TAGNAME:PROC( (TAG,MONAT,JAHR) FIXED(15)) RETURNS(CHAR(10));

  RETURN(DAYNAME(WOCHENTAG(JAHR,TAGESNUMMER(JAHR,MONAT,TAG))));
       
END; /* TAGNAME:PROC */

! *******************************************************************
! *           MONATNAME ORDNET JEDEM TAG EINEN NAMEN ZU !           *
! *******************************************************************

! MONATNAME:PROC( MONAT FIXED(15)) RETURNS(CHAR(3));
!
! This function has been replaced by an array of constants



